import type { QueryObject } from 'ufo';
import type { H3Event } from 'h3';
import type { FetchOptions, FetchResponse, FetchError } from 'ofetch';
import type { GraphqlMiddlewareRequestContext, GraphqlMiddlewareRuntimeConfig, GraphqlMiddlewareServerOptions } from './../../types.js';
import { type GraphqlMiddlewareOperation } from './../../settings/index.js';
import type { Mutation, Query } from '#nuxt-graphql-middleware/operation-types';
export declare function isValidMutation(v?: string): v is keyof Mutation;
export declare function isValidQuery(v?: string): v is keyof Query;
export declare function queryParamToVariables(query: QueryObject): any;
/**
 * Extract the client context from the query params.
 */
export declare function extractRequestContext(query: QueryObject): GraphqlMiddlewareRequestContext<any>;
/**
 * Get the URL of the GraphQL endpoint.
 */
export declare function getEndpoint(config: GraphqlMiddlewareRuntimeConfig, serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, operation: GraphqlMiddlewareOperation | null, operationName: string | null, context: GraphqlMiddlewareRequestContext<any> | null): string | Promise<string>;
/**
 * Get the options for the $fetch request to the GraphQL server.
 */
export declare function getFetchOptions(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, operation: GraphqlMiddlewareOperation | null, operationName: string | null, context: GraphqlMiddlewareRequestContext<any> | null): FetchOptions | Promise<FetchOptions>;
export declare function throwError(statusMessage: string, statusCode?: number): never;
/**
 * Handle GraphQL server response.
 */
export declare function onServerResponse(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, response: FetchResponse<any>, operation: string | null, operationName: string | null, context: GraphqlMiddlewareRequestContext<any> | null): any;
/**
 * Handle GraphQL server errors.
 */
export declare function onServerError(serverOptions: GraphqlMiddlewareServerOptions<any, any>, event: H3Event, error: FetchError, operation: string | null, operationName: string | null, context: GraphqlMiddlewareRequestContext<any> | null): any;
